/*
* $XConsortium: Text.h,v 1.32 89/10/19 15:01:11 kit Exp $
*/


/***********************************************************
Copyright 1987, 1988 by Digital Equipment Corporation, Maynard, Massachusetts,
and the Massachusetts Institute of Technology, Cambridge, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Digital or MIT not be
used in advertising or publicity pertaining to distribution of the
software without specific, written prior permission.  

DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/

#ifndef _XawText_h
#define _XawText_h

#ifndef _XawTextTypes_h
#include "TextTypes.h"
#endif
#ifndef _XawTextSink_h
#include "TextSink.h"
#endif
#ifndef _XawTextSrc_h
#include "TextSrc.h"
#endif

/****************************************************************
 *
 * Text widget
 *
 ****************************************************************/

/* Parameters:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		Pixel		XtDefaultBackground
 border		     BorderColor	Pixel		XtDefaultForeground
 borderWidth	     BorderWidth	Dimension	1
 destroyCallback     Callback		Pointer		NULL
 dialogHOffset	     Margin		int		10
 dialogVOffset	     Margin		int		10
 displayCaret	     Output		Boolean		True
 displayPosition     TextPosition	int		0
 editType	     EditType		XtTextEditType	XttextRead
 height		     Height		Dimension	font height
 insertPosition	     TextPosition	int		0
 leftMargin	     Margin		Dimension	2
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 selectTypes	     SelectTypes	Pointer		(internal)
 selection	     Selection		Pointer		empty selection
 sensitive	     Sensitive		Boolean		True
 textSink	     TextSink		Pointer		(none)
 textSource	     TextSource		Pointer		(none)
 width		     Width		Dimension	100
 x		     Position		int		0
 y		     Position		int		0

*/

#define XtEtextScrollNever "never"
#define XtEtextScrollWhenNeeded "whenneeded"
#define XtEtextScrollAlways "always"

#define XtEtextWrapNever "never"
#define XtEtextWrapLine "line"
#define XtEtextWrapWord "word"

#define XtEtextResizeNever "never"
#define XtEtextResizeWidth "width"
#define XtEtextResizeHeight "height"
#define XtEtextResizeBoth "both"

#define XtNautoFill "autoFill"
#define XtNbottomMargin "bottomMargin"
#define XtNdialogHOffset "dialogHOffset"
#define XtNdialogVOffset "dialogVOffset"
#define XtNdisplayCaret "displayCaret"
#define XtNdisplayPosition "displayPosition"
#define XtNinsertPosition "insertPosition"
#define XtNleftMargin "leftMargin"
#define XtNresize "resize"
#define XtNrightMargin "rightMargin"
#define XtNscrollVertical "scrollVertical"
#define XtNscrollHorizontal "scrollHorizontal"
#define XtNselectTypes "selectTypes"
#define XtNselection "selection"
#define XtNtopMargin "topMargin"
#define XtNwrap "wrap"

#define XtCAutoFill "AutoFill"
#define XtCResize "Resize"
#define XtCScroll "Scroll"
#define XtCSelectTypes "SelectTypes"
#define XtCWrap "Wrap"

/* Return Error code for XawTextSearch */

#define XawTextSearchError      (-12345L)

/* Return codes from XawTextReplace */

#define XawEditDone		0
#define XawEditError		1
#define XawPositionError	2

extern Atom FMT8BIT;

/* Class record constants */

extern WidgetClass textWidgetClass;

typedef struct _TextClassRec *TextWidgetClass;
typedef struct _TextRec      *TextWidget;

#ifdef XAW_BC
/************************************************************
 *
 * This Stuff is only for compatibility, and will go away in 
 * future releases.                                         */

/* preserved for Back Compatability only. */

#define XawTextSource Widget
#define XtTextSource  Widget

#define wordBreak		0x01
#define scrollVertical		0x02
#define scrollHorizontal	0x04
#define scrollOnOverflow	0x08
#define resizeWidth		0x10
#define resizeHeight		0x20
#define editable		0x40

typedef long XtTextPosition;

#define XtTextBlock                XawTextBlock
#define XtTextBlockPtr             XawTextBlockPtr

#define EditDone	           XawEditDone
#define EditError	           XawEditError
#define PositionError	           XawPositionError

#define XtEditDone	           XawEditDone
#define XtEditError	           XawEditError
#define XtPositionError	           XawPositionError

#define XttextRead                 XawtextRead
#define XttextAppend               XawtextAppend
#define XttextEdit                 XawtextEdit
#define XtTextEditType             XawTextEditType
#define XtselectNull               XawselectNull

#define XtselectPosition           XawselectPosition
#define XtselectChar               XawselectChar
#define XtselectWord               XawselectWord
#define XtselectLine               XawselectLine
#define XtselectParagraph          XawselectParagraph
#define XtselectAll                XawselectAll
#define XtTextSelectType           XawTextSelectType

#define XtTextDisableRedisplay     XawTextDisableRedisplay
#define XtTextEnableRedisplay      XawTextEnableRedisplay
#define XtTextGetSource            XawTextGetSource

#define XtTextDisplay              XawTextDisplay
#define XtTextDisplayCaret         XawTextDisplayCaret
#define XtTextSetSelectionArray    XawTextSetSelectionArray
#define XtTextSetLastPos           XawTextSetLastPos
#define XtTextGetSelectionPos      XawTextGetSelectionPos
#define XtTextSetSource            XawTextSetSource
#define XtTextReplace              XawTextReplace
#define XtTextTopPosition          XawTextTopPosition
#define XtTextSetInsertionPoint    XawTextSetInsertionPoint
#define XtTextGetInsertionPoint    XawTextGetInsertionPoint
#define XtTextUnsetSelection       XawTextUnsetSelection
#define XtTextChangeOptions        XawTextChangeOptions
#define XtTextGetOptions           XawTextGetOptions
#define XtTextSetSelection         XawTextSetSelection
#define XtTextInvalidate           XawTextInvalidate

#define XtDiskSourceCreate         XawDiskSourceCreate
#define XtDiskSourceDestroy        XawDiskSourceDestroy
#define XtStringSourceCreate       XawStringSourceCreate
#define XtStringSourceDestroy      XawStringSourceDestroy

extern void XawTextChangeOptions(
	Widget	w,
	int	options
); /* w, options */
    /* Widget        w;		*/
    /* int    options; */

extern int XawTextGetOptions(
	Widget	w
); /* w */
    /* Widget        w;		*/

extern void XawTextSetLastPos(
	Widget	w,
	XawTextPosition	lastPos
); /* w, lastPos */
    /* Widget        w;		*/
    /* XawTextPosition lastPos;  */

/*************************************************************/
#endif /* XAW_BC */

extern void XawTextDisplay(
	Widget		w
); /* w */
    /* Widget w; */

extern void XawTextEnableRedisplay(
	Widget		w
); /* w */
    /* Widget w; */

extern void XawTextDisableRedisplay(
	Widget		w
); /* w */
    /* Widget w; */

extern void XawTextSetSelectionArray(
	Widget			w,
	XawTextSelectType	*sarray
); /* w, sarray */
    /* Widget        w;		*/
    /* XawTextSelectType *sarray;   */

extern void XawTextGetSelectionPos(
	Widget		w,
	XawTextPosition	*begin_return,
	XawTextPosition	*end_return
); /* w, left, right */
    /* Widget        w;		*/
    /* XawTextPosition *left, *right;    */

extern void XawTextSetSource(
	Widget		w,
	Widget		source,
	XawTextPosition	position
); /* w, source, startPos */
    /* Widget         w;	    */
    /* XawTextSource   source; (== Widget)*/
    /* XawTextPosition startPos;     */

extern int XawTextReplace(
	Widget		w,
	XawTextPosition	start,
	XawTextPosition	end,
	XawTextBlock	*text
); /* w, startPos, endPos, text */
    /* Widget        w;		*/
    /* XawTextPosition   startPos, endPos; */
    /* XawTextBlock      *text; */

extern XawTextPosition XawTextTopPosition(
	Widget		w
); /* w */
    /* Widget        w;		*/

extern void XawTextSetInsertionPoint(
	Widget		w,
	XawTextPosition	position
); /*  w, position */
    /* Widget        w;		*/
    /* XawTextPosition position; */

extern XawTextPosition XawTextGetInsertionPoint(
	Widget		w
); /* w */
    /* Widget        w;		*/

extern void XawTextUnsetSelection(
	Widget		w
); /* w */
    /* Widget        w;		*/

extern void XawTextSetSelection(
	Widget		w,
	XawTextPosition	left,
	XawTextPosition	right
); /* w, left, right */
    /* Widget        w;		*/
    /* XawTextPosition left, right; */

extern void XawTextInvalidate(
	Widget		w,
	XawTextPosition	from,
	XawTextPosition	to
); /* w, from, to */
    /* Widget        w;		*/
    /* XawTextPosition from, to; */

extern Widget XawTextGetSource(
	Widget		w
) ; /* w */
    /* Widget        w;		*/

extern XawTextPosition XawTextSearch(
	Widget			w,
	XawTextScanDirection	dir,
	XawTextBlock		*text
) ; /* w, dir, text */
    /* Widget        w;		 */
    /* XawTextScanDirection dir; */
    /* XawTextBlock      *text;  */

extern void XawTextDisplayCaret(
	Widget		w,
	int		visible	/* Boolean */
) ; /* w, visible */
    /* Widget  w;       */
    /* Boolean visible; */

/*
 * For R3 compatability only. 
 */

#ifndef _XawAsciiSrc_h
#include "AsciiSrc.h"
#endif
#ifndef _XawAsciiSink_h
#include "AsciiSink.h"
#endif

#endif /* _XawText_h */
/* DON'T ADD STUFF AFTER THIS #endif */
