/*
 * $XConsortium: Drawing.h,v 1.3 89/10/03 08:37:53 rws Exp $
 *
 * Copyright 1988 by the Massachusetts Institute of Technology
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided 
 * that the above copyright notice appear in all copies and that both that 
 * copyright notice and this permission notice appear in supporting 
 * documentation, and that the name of M.I.T. not be used in advertising
 * or publicity pertaining to distribution of the software without specific, 
 * written prior permission. M.I.T. makes no representations about the 
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 *
 * The X Window System is a Trademark of MIT.
 *
 * The interfaces described by this header file are for miscellaneous utilities
 * and are not part of the Xlib standard.
 */

#ifndef _XMU_DRAWING_H_
#define _XMU_DRAWING_H_

#ifndef __stdio_h
#include <stdio.h>
#endif
#ifndef _XLIB_H_
#include "../Xlib.h"
#endif

void XmuDrawRoundedRectangle(Display*,Drawable,GC, int x, int y, int w, int h, int ew, int eh);
void XmuFillRoundedRectangle(Display*,Drawable,GC, int x, int y, int w, int h, int ew, int eh);
void XmuDrawLogo(Display*,Drawable, GC fore, GC back, int x, int y, unsigned w, unsigned h);
Pixmap XmuCreateStippledPixmap(Screen *, unsigned long fg, unsigned long bg, unsigned depth);
void XmuReleaseStippledPixmap(Screen *, Pixmap);
int XmuReadBitmapData(FILE*,unsigned *w,unsigned *h,unsigned char **dp,int *x,int *y);
int XmuReadBitmapDataFromFile(char*,unsigned *w,unsigned *h,unsigned char **dp,int *x,int *y);
Pixmap XmuLocateBitmapFile(Screen*,char*,char* out,int outlen,int* w,int* h,int* x,int* y);
Pixmap XmuCreatePixmapFromBitmap(Display*, Drawable, Pixmap bitmap,
				unsigned w, unsigned h, unsigned depth,
				unsigned long fg, unsigned long bg);

#endif /* _XMU_DRAWING_H_ */
