/* This symbol must always be defined when compiling for Motif.  This is to
 * ensure that the correct set of Xt header files are used (ie those in
 * /usr/include/Xm rather than the X11 Release 4 ones in /usr/include/X11).
 * All the R4 Xt headers check for this symbol; if it is defined, they give
 * an error.
 */

#ifndef _MOTIF_XT
#define _MOTIF_XT
#endif

#ifdef REV_INFO
#ifndef lint
static char SCCSID[] = "OSF/Motif: @(#)LabelGP.h	1.1 89/07/19";
#endif /* lint */
#endif /* REV_INFO */
/******************************************************************************
*******************************************************************************
*
*  (c) Copyright 1989, OPEN SOFTWARE FOUNDATION, INC.
*  (c) Copyright 1989, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS.
*  (c) Copyright 1987, 1988, 1989 HEWLETT-PACKARD COMPANY
*  ALL RIGHTS RESERVED
*  
*  	THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED
*  AND COPIED ONLY IN ACCORDANCE WITH THE TERMS OF SUCH LICENSE AND
*  WITH THE INCLUSION OF THE ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR
*  ANY OTHER COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE
*  AVAILABLE TO ANY OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF THE
*  SOFTWARE IS HEREBY TRANSFERRED.
*  
*  	THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT
*  NOTICE AND SHOULD NOT BE CONSTRUED AS A COMMITMENT BY OPEN SOFTWARE
*  FOUNDATION, INC. OR ITS THIRD PARTY SUPPLIERS  
*  
*  	OPEN SOFTWARE FOUNDATION, INC. AND ITS THIRD PARTY SUPPLIERS,
*  ASSUME NO RESPONSIBILITY FOR THE USE OR INABILITY TO USE ANY OF ITS
*  SOFTWARE .   OSF SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
*  KIND, AND OSF EXPRESSLY DISCLAIMS ALL IMPLIED WARRANTIES, INCLUDING
*  BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
*  FITNESS FOR A PARTICULAR PURPOSE.
*  
*  Notice:  Notwithstanding any other lease or license that may pertain to,
*  or accompany the delivery of, this computer software, the rights of the
*  Government regarding its use, reproduction and disclosure are as set
*  forth in Section 52.227-19 of the FARS Computer Software-Restricted
*  Rights clause.
*  
*  (c) Copyright 1989, Open Software Foundation, Inc.  Unpublished - all
*  rights reserved under the Copyright laws of the United States.
*  
*  RESTRICTED RIGHTS NOTICE:  Use, duplication, or disclosure by the
*  Government is subject to the restrictions as set forth in subparagraph
*  (c)(1)(ii) of the Rights in Technical Data and Computer Software clause
*  at DFARS 52.227-7013.
*  
*  Open Software Foundation, Inc.
*  11 Cambridge Center
*  Cambridge, MA   02142
*  (617)621-8700
*  
*  RESTRICTED RIGHTS LEGEND:  This computer software is submitted with
*  "restricted rights."  Use, duplication or disclosure is subject to the
*  restrictions as set forth in NASA FAR SUP 18-52.227-79 (April 1985)
*  "Commercial Computer Software- Restricted Rights (April 1985)."  Open
*  Software Foundation, Inc., 11 Cambridge Center, Cambridge, MA  02142.  If
*  the contract contains the Clause at 18-52.227-74 "Rights in Data General"
*  then the "Alternate III" clause applies.
*  
*  (c) Copyright 1989, Open Software Foundation, Inc.
*  ALL RIGHTS RESERVED 
*  
*  
* Open Software Foundation is a trademark of The Open Software Foundation, Inc.
* OSF is a trademark of Open Software Foundation, Inc.
* OSF/Motif is a trademark of Open Software Foundation, Inc.
* Motif is a trademark of Open Software Foundation, Inc.
* DEC is a registered trademark of Digital Equipment Corporation
* DIGITAL is a registered trademark of Digital Equipment Corporation
* X Window System is a trademark of the Massachusetts Institute of Technology
*
*******************************************************************************
******************************************************************************/
#ifndef _XmLabelGP_h
#define _XmLabelGP_h

#ifndef _XmLabelG_h
#include "LabelG.h"
#endif
#ifndef _XmP_h
#include "XmP.h"
#endif

/*  The Label Widget Class and instance records  */

typedef struct _XmLabelGadgetClassPart     /* label class record */
{
        XtProc		setOverrideCallback;
        XtProc		setWhichButton;
        caddr_t		extension; /* Pointer to extension record */
} XmLabelGadgetClassPart;

typedef struct _XmLabelGadgetClassRec
{
    RectObjClassPart       rect_class;
    XmGadgetClassPart      gadget_class;
    XmLabelGadgetClassPart label_class;
} XmLabelGadgetClassRec;

extern XmLabelGadgetClassRec xmLabelGadgetClassRec;


/* Inherited  Functions exported by label */

#define XmInheritSetOverrideCallback ((XtProc) _XtInherit)
#define XmInheritSetWhichButton ((XtProc) _XtInherit)
#define XmInheritResize  ((XtProc) _XtInherit)

/* Padding between label text and accelerator text */

#define LABELG_ACC_PAD		15


/*  The Label instance record  */

typedef struct _XmLabelGadgetPart
{
	_XmString	_label;  /* String sent to this widget */
        _XmString       _acc_text;
        char            mnemonic;
        unsigned char	label_type;
        unsigned char	alignment;
        unsigned char	string_direction;
        XmFontList	font;
	
	short	margin_height;   /* margin around widget */
	short	margin_width;

	short	margin_left;    /* additional margins on */
	short	margin_right;   /* each side of widget */
	short	margin_top;     /* text (or pixmap) is placed */
	short   margin_bottom;  /* inside the margins */

	Boolean recompute_size;

        Pixmap		pixmap; 
        Pixmap		pixmap_insen; 


        /* PRIVATE members -- values computed by LabelWidgetClass methods */

        GC		normal_GC;   /* GC for text */	
	GC		insensitive_GC;
        XRectangle	TextRect;    /* The bounding box of the text, or clip
                                        rectangle of the window; whichever is
                                        smaller */
        XRectangle	acc_TextRect; /* The bounding box of the text, or clip
                                        rectangle of the window; whichever is
                                        smaller */

        XtProc		*override_callback;

        _XmString	_mnemonic;
        char 		*accelerator;
        unsigned int	which_button;
} XmLabelGadgetPart;


typedef struct _XmLabelGadgetRec
{
   ObjectPart        object;
   RectObjPart       rectangle;
   XmGadgetPart      gadget;
   XmLabelGadgetPart label;
} XmLabelGadgetRec;

/* MACROS */

#define LabG_MarginWidth(w)		(((XmLabelGadget)(w)) -> \
                                           label.margin_width)
#define LabG_MarginHeight(w)		(((XmLabelGadget)(w)) -> \
                                           label.margin_height)
#define LabG_MarginTop(w)		(((XmLabelGadget)(w)) -> \
                                           label.margin_top)
#define LabG_MarginBottom(w)		(((XmLabelGadget)(w)) -> \
                                           label.margin_bottom)
#define LabG_MarginRight(w)		(((XmLabelGadget)(w)) -> \
                                           label.margin_right)
#define LabG_MarginLeft(w)		(((XmLabelGadget)(w)) -> \
                                           label.margin_left)
#define LabG_TextRect_x(w)		(((XmLabelGadget)(w)) -> \
                                           label.TextRect.x)
#define LabG_TextRect_y(w)		(((XmLabelGadget)(w)) -> \
                                           label.TextRect.y)
#define LabG_TextRect_width(w)		(((XmLabelGadget)(w)) -> \
                                           label.TextRect.width)
#define LabG_TextRect_height(w)		(((XmLabelGadget)(w)) -> \
                                           label.TextRect.height)

#define LabG_IsText(w)			(((XmLabelGadget)(w)) -> \
                                           label.label_type == XmSTRING)
#define LabG_IsPixmap(w)		(((XmLabelGadget)(w)) -> \
                                           label.label_type == XmPIXMAP)

#define LabG_Font(w)			(((XmLabelGadget)(w)) ->label.font)

#define LabG_Mnemonic(w)		(((XmLabelGadget)(w)) ->label.mnemonic)
#define LabG_Accelerator(w)		(((XmLabelGadget)(w)) -> \
                                           label.accelerator)
#define LabG_AcceleratorText(w)		(((XmLabelGadget)(w)) ->label.acc_text)

#define LabG_WhichButton(w)		(((XmLabelGadget)(w)) -> \
                                           label.which_button)

#endif /* _XmLabelGP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
