/* This symbol must always be defined when compiling for Motif.  This is to
 * ensure that the correct set of Xt header files are used (ie those in
 * /usr/include/Xm rather than the X11 Release 4 ones in /usr/include/X11).
 * All the R4 Xt headers check for this symbol; if it is defined, they give
 * an error.
 */

#ifndef _MOTIF_XT
#define _MOTIF_XT
#endif

#ifdef REV_INFO
#ifndef lint
static char SCCSID[] = "OSF/Motif: @(#)StringDefs.h	1.1 89/07/19";
#endif /* lint */
#endif /* REV_INFO */
/******************************************************************************
*******************************************************************************
*
*  (c) Copyright 1989, OPEN SOFTWARE FOUNDATION, INC.
*  (c) Copyright 1989, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS.
*  (c) Copyright 1987, 1988, 1989 HEWLETT-PACKARD COMPANY
*  (c) Copyright 1988 MASSACHUSETTS INSTITUTE OF TECHNOLOGY 
*  ALL RIGHTS RESERVED
*  
*  	THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED
*  AND COPIED ONLY IN ACCORDANCE WITH THE TERMS OF SUCH LICENSE AND
*  WITH THE INCLUSION OF THE ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR
*  ANY OTHER COPIES THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE
*  AVAILABLE TO ANY OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF THE
*  SOFTWARE IS HEREBY TRANSFERRED.
*  
*  	THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT
*  NOTICE AND SHOULD NOT BE CONSTRUED AS A COMMITMENT BY OPEN SOFTWARE
*  FOUNDATION, INC. OR ITS THIRD PARTY SUPPLIERS  
*  
*  	OPEN SOFTWARE FOUNDATION, INC. AND ITS THIRD PARTY SUPPLIERS,
*  ASSUME NO RESPONSIBILITY FOR THE USE OR INABILITY TO USE ANY OF ITS
*  SOFTWARE .   OSF SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
*  KIND, AND OSF EXPRESSLY DISCLAIMS ALL IMPLIED WARRANTIES, INCLUDING
*  BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
*  FITNESS FOR A PARTICULAR PURPOSE.
*  
*  Notice:  Notwithstanding any other lease or license that may pertain to,
*  or accompany the delivery of, this computer software, the rights of the
*  Government regarding its use, reproduction and disclosure are as set
*  forth in Section 52.227-19 of the FARS Computer Software-Restricted
*  Rights clause.
*  
*  (c) Copyright 1989, Open Software Foundation, Inc.  Unpublished - all
*  rights reserved under the Copyright laws of the United States.
*  
*  RESTRICTED RIGHTS NOTICE:  Use, duplication, or disclosure by the
*  Government is subject to the restrictions as set forth in subparagraph
*  (c)(1)(ii) of the Rights in Technical Data and Computer Software clause
*  at DFARS 52.227-7013.
*  
*  Open Software Foundation, Inc.
*  11 Cambridge Center
*  Cambridge, MA   02142
*  (617)621-8700
*  
*  RESTRICTED RIGHTS LEGEND:  This computer software is submitted with
*  "restricted rights."  Use, duplication or disclosure is subject to the
*  restrictions as set forth in NASA FAR SUP 18-52.227-79 (April 1985)
*  "Commercial Computer Software- Restricted Rights (April 1985)."  Open
*  Software Foundation, Inc., 11 Cambridge Center, Cambridge, MA  02142.  If
*  the contract contains the Clause at 18-52.227-74 "Rights in Data General"
*  then the "Alternate III" clause applies.
*  
*  (c) Copyright 1989, Open Software Foundation, Inc.
*  ALL RIGHTS RESERVED 
*  
*  
* Open Software Foundation is a trademark of The Open Software Foundation, Inc.
* OSF is a trademark of Open Software Foundation, Inc.
* OSF/Motif is a trademark of Open Software Foundation, Inc.
* Motif is a trademark of Open Software Foundation, Inc.
* DEC is a registered trademark of Digital Equipment Corporation
* DIGITAL is a registered trademark of Digital Equipment Corporation
* X Window System is a trademark of the Massachusetts Institute of Technology
*
*******************************************************************************
******************************************************************************/

#ifndef _XtAtom_h_
#define _XtAtom_h_

/* Resource names */

#define XtNaccelerators         "accelerators"
#define XtNallowHoriz		"allowHoriz"
#define XtNallowVert		"allowVert"
#define XtNancestorSensitive	"ancestorSensitive"
#define XtNbackground		"background"
#define XtNbackgroundPixmap     "backgroundPixmap"
#define XtNbitmap		"bitmap"
#define XtNborderColor		"borderColor"
#define XtNborder		"borderColor"
#define XtNborderPixmap		"borderPixmap"
#define XtNborderWidth		"borderWidth"
#define XtNcallback		"callback"
#define XtNcolormap		"colormap"
#define XtNdepth		"depth"
#define XtNdestroyCallback      "destroyCallback"
#define XtNeditType		"editType"
#define XtNfile			"file"
#define XtNfont			"font"
#define XtNforceBars		"forceBars"
#define XtNforeground		"foreground"
#define XtNfunction		"function"
#define XtNheight		"height"
#define XtNhighlight		"highlight"
#define XtNhSpace		"hSpace"
#define XtNindex		"index"
#define XtNinnerHeight		"innerHeight"
#define XtNinnerWidth		"innerWidth"
#define XtNinnerWindow		"innerWindow"
#define XtNinsertPosition	"insertPosition"
#define XtNinternalHeight	"internalHeight"
#define XtNinternalWidth	"internalWidth"
#define XtNjumpProc		"jumpProc"
#define XtNjustify		"justify"
#define XtNknobHeight		"knobHeight"
#define XtNknobIndent		"knobIndent"
#define XtNknobPixel		"knobPixel"
#define XtNknobWidth		"knobWidth"
#define XtNlabel		"label"
#define XtNlength		"length"
#define XtNlowerRight		"lowerRight"
#define XtNmappedWhenManaged	"mappedWhenManaged"
#define XtNmenuEntry		"menuEntry"
#define XtNname			"name"
#define XtNnotify		"notify"
#define XtNorientation		"orientation"
#define XtNparameter		"parameter"
#define XtNpixmap		"pixmap"
#define XtNpopupCallback	"popupCallback"
#define XtNpopdownCallback	"popdownCallback"
#define XtNresize		"resize"
#define XtNreverseVideo		"reverseVideo"
#define XtNscreen               "screen"
#define XtNscrollProc		"scrollProc"
#define XtNscrollDCursor	"scrollDCursor"
#define XtNscrollHCursor	"scrollHCursor"
#define XtNscrollLCursor	"scrollLCursor"
#define XtNscrollRCursor	"scrollRCursor"
#define XtNscrollUCursor	"scrollUCursor"
#define XtNscrollVCursor	"scrollVCursor"
#define XtNselection		"selection"
#define XtNselectionArray	"selectionArray"
#define XtNsensitive		"sensitive"
#define XtNshown		"shown"
#define XtNspace		"space"
#define XtNstring		"string"
#define XtNtextOptions		"textOptions"
#define XtNtextSink		"textSink"
#define XtNtextSource		"textSource"
#define XtNthickness		"thickness"
#define XtNthumb		"thumb"
#define XtNthumbProc		"thumbProc"
#define XtNtop			"top"
#define XtNtranslations		"translations"
#define XtNupdate		"update"
#define XtNuseBottom		"useBottom"
#define XtNuseRight		"useRight"
#define XtNvalue		"value"
#define XtNvSpace		"vSpace"
#define XtNwidth		"width"
#define XtNwindow		"window"
#define XtNx			"x"
#define XtNy			"y"

/* Class types */ 
#define XtCAccelerators         "Accelerators"
#define XtCBackground		"Background"
#define XtCBitmap		"Bitmap"
#define XtCBoolean		"Boolean"
#define XtCBorderColor		"BorderColor"
#define XtCBorderWidth		"BorderWidth"
#define XtCCallback             "Callback"
#define XtCColormap		"Colormap"
#define XtCColor		"Color"
#define XtCCursor		"Cursor"
#define XtCDepth		"Depth"
#define XtCEditType		"EditType"
#define XtCEventBindings	"EventBindings"
#define XtCFile			"File"
#define XtCFont			"Font"
#define XtCForeground		"Foreground"
#define XtCFraction		"Fraction"
#define XtCFunction		"Function"
#define XtCHeight		"Height"
#define XtCHSpace		"HSpace"
#define XtCIndex		"Index"
#define XtCInsertPosition	"InsertPosition"
#define XtCInterval		"Interval"
#define XtCJustify		"Justify"
#define XtCKnobIndent		"KnobIndent"
#define XtCKnobPixel		"KnobPixel"
#define XtCLabel		"Label"
#define XtCLength		"Length"
#define XtCMappedWhenManaged	"MappedWhenManaged"
#define XtCMargin		"Margin"
#define XtCMenuEntry		"MenuEntry"
#define XtCNotify		"Notify"
#define XtCOrientation		"Orientation"
#define XtCParameter		"Parameter"
#define XtCPixmap		"Pixmap"
#define XtCPosition		"Position"
#define XtCResize		"Resize"
#define XtCReverseVideo		"ReverseVideo"
#define XtCScreen               "Screen"
#define XtCScrollProc		"ScrollProc"
#define XtCScrollDCursor	"ScrollDCursor"
#define XtCScrollHCursor	"ScrollHCursor"
#define XtCScrollLCursor	"ScrollLCursor"
#define XtCScrollRCursor	"ScrollRCursor"
#define XtCScrollUCursor	"ScrollUCursor"
#define XtCScrollVCursor	"ScrollVCursor"
#define XtCSelection		"Selection"
#define XtCSensitive		"Sensitive"
#define XtCSelectionArray	"SelectionArray"
#define XtCSpace		"Space"
#define XtCString		"String"
#define XtCTextOptions		"TextOptions"
#define XtCTextPosition		"TextPosition"
#define XtCTextSink		"TextSink"
#define XtCTextSource		"TextSource"
#define XtCThickness		"Thickness"
#define XtCThumb		"Thumb"
#define XtCTranslations		"Translations"
#define XtCValue		"Value"
#define XtCVSpace		"VSpace"
#define XtCWidth		"Width"
#define XtCWindow		"Window"
#define XtCX			"X"
#define XtCY			"Y"

/* Representation types */

#define XtRAcceleratorTable     "AcceleratorTable"
#define XtRBool			"Bool"
#define XtRBoolean		"Boolean"
#define XtRCallback             "Callback"
#define XtRCallProc             "CallProc"
#define XtRColor		"Color"
#define XtRCursor		"Cursor"
#define XtRDimension		"Dimension"
#define XtRDisplay		"Display"
#define XtREditMode		"EditMode"
#define XtRFile			"File"
#define XtRFont			"Font"
#define XtRFontStruct		"FontStruct"
#define XtRFunction		"Function"
#define XtRGeometry		"Geometry"
#define XtRImmediate		"Immediate"
#define XtRInt			"Int"
#define XtRJustify		"Justify"
#define XtRLongBoolean		XtRBool		/* Compatibility */
#define XtROrientation		"Orientation"
#define XtRPixel		"Pixel"
#define XtRPixmap		"Pixmap"
#define XtRPointer		"Pointer"
#define XtRPosition		"Position"
#define XtRShort                "Short"
#define XtRString		"String"
#define XtRStringTable		"StringTable"
#define XtRUnsignedChar         "UnsignedChar"
#define XtRTranslationTable     "TranslationTable"
#define XtRWindow		"Window"


/* Boolean enumeration constants */

#define XtEoff			"off"
#define XtEfalse		"false"
#define XtEno			"no"
#define XtEon			"on"
#define XtEtrue			"true"
#define XtEyes			"yes"

/* Orientation enumeration constants */

#define XtEvertical		"vertical"
#define XtEhorizontal		"horizontal"

/* text edit enumeration constants */

#define XtEtextRead		"read"
#define XtEtextAppend		"append"
#define XtEtextEdit		"edit"

/* color enumeration constants */

#define XtExtdefaultbackground  "xtdefaultbackground"
#define XtExtdefaultforeground  "xtdefaultforeground"

/* font constant */

#define XtExtdefaultfont	"xtdefaultfont"

#endif /* _XtAtom_h_ */
/* DON'T ADD STUFF AFTER THIS #endif */
