/* $Header: /smsa/bsd:include/arm/apcsreg.h:bsd  1.2  $
 * $Source: /smsa/bsd:include/arm/apcsreg.h: $
 *
 * $Desc:	apcsreg.h,v $
 *	Binding of registers in this version of the ARM
 *	procedure call standard.
 *
 * Copyright (c) 1989 Acorn Computers Ltd
 *
 */

#ifndef __arm_apcsreg_h
#define	__arm_apcsreg_h
#define	__machine_apcsreg_h	"arm"

/* Argument registers */
#define APCS_A1 0
#define APCS_A2 1
#define APCS_A3 2
#define APCS_A4 3

/* Callee save registers (register variables) */
#define APCS_V1 4
#define APCS_V2 5
#define APCS_V3 6
#define APCS_V4 7
#define APCS_V5 8
#define APCS_V6 9

/* Call frame registers */
#define APCS_SL 10
#define APCS_FP 11
#define APCS_IP 12
#define APCS_SP 13

/* Hardware defined registers */
#define APCS_LR 14
#define APCS_PC 15

/* Instruction patterns */
#define APCS_RSM_INSTRUCTION 0xE92DD800
#define APCS_FPS_INSTRUCTION 0xED6D4103

#endif/*__arm_apcsreg_h*/

/* EOF apcs_reg.h */
