/*
 * $Header: /smsa/bsd:include/arm/delay.h:bsd  1.5  $
 * $Source: /smsa/bsd:include/arm/delay.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 *
 */
#ifndef	__arm_delay_h
#define	__arm_delay_h
#define	__machine_delay_h	"arm"

/* delay.h
 *
 * The MICRODELAY macro provides a cpu-busy-wait to give a short timing
 * slug for nefarious purposes.  Note that it should have the effect
 * of waiting for AT LEAST the specified period:  depending on the
 * compiler, it may well hang about for a little longer...
 *
 * The effect of the MICRODELAY macro is now just to call the DELAY_ 
 * function (implemented in delay.s) with the desired delay in 
 * microseconds as parameter.  The actual function takes care of
 * speed adjustments according to its operating environment.
 *
 */

extern void DELAY_();

#define  MICRODELAY(microseconds) DELAY_(microseconds)

#endif/*__arm_delay_h*/

/* EOF delay.h */
