/*
 * $Header: /smsa/bsd:include/arm/ioctrans.h:bsd  1.4  $
 * $Source: /smsa/bsd:include/arm/ioctrans.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 *
 */

#ifndef __arm_ioctrans_h
#define	__arm_ioctrans_h
#define	__machine_ioctrans_h	"arm"

/*
 *	ARM Interrupt interface - interrupt control structures
 *
 *	Author: J.M. Collins, Xi Software Ltd 1986.
 *
 *	The following structure declares the details of a segment of a
 *	transfer.  We have a single-linked list of such to cover the
 *	whole of a given transfer.
 */

struct	ioctrans	{
	size_t	ioc_count;		/*  Byte count  */
	caddr_t	ioc_addr;		/*  Virtual address  */
	struct	ioctrans  *ioc_nxt;	/*  Next one or NULL(zero)  */
};

#define	IT_READ	1			/*  Read flag  */

#endif/*__arm_ioctrans_h*/

/* EOF ioctrans.h */
