/*
 * $Header: /smsa/bsd:include/assert.h:bsd  1.5  $
 * $Source: /smsa/bsd:include/assert.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 */
/*	assert.h	4.2	85/01/21	*/

/* Note that (see ANSI rationale section 4.3) <assert.h> may be included */
/* more that once in a program with different setting of NDEBUG.         */
/* Hence the slightly unusual first-time only flag.                      */

#ifndef __assert_h
#  define __assert_h
   extern void __assert(const char *, const char *, int);
#else
#  undef assert
#endif

#ifdef NDEBUG
#  define assert(ignore) ((void)0)
#else
#ifdef __STDC__
#  define assert(e) ((e) ? (void)0 : __assert(#e, __FILE__, __LINE__))
#else
#  define assert(e) ((e) ? (void)0 : __assert("e", __FILE__, __LINE__))
#endif
#endif

/* end of assert.h */
