/*
 * $Header: /smsa/bsd:include/cpio.h:bsd  1.2  $
 * $Source: /smsa/bsd:include/cpio.h: $
 *
 * Copyright (c) 1990 Acorn Computers Ltd., Cambridge, England
 */

/*
 * Cpio format definitions, for X/Open conformance: details derived
 * from POSIX.  Definitions extracted from IEEE Std 1003.1-1988 and
 * XPG3 vol 3, page 161.
 */

#ifndef __cpio_h
#define __cpio_h

/*
 * Bits in the c_mode field of the cpio archive header.
 */
#define	C_IRUSR		0000400			/* read by owner */
#define	C_IWUSR		0000200			/* write by owner */
#define	C_IXUSR		0000100			/* execute by owner */
#define	C_IRGRP		0000040                 /* read by group */   
#define	C_IWGRP		0000020                 /* write by group */  
#define	C_IXGRP		0000010                 /* execute by group */
#define	C_IROTH		0000004                 /* read by others */   
#define	C_IWOTH		0000002                 /* write by others */  
#define	C_IXOTH		0000001                 /* execute by others */
#define	C_ISUID		0004000			/* set uid on exec */
#define	C_ISGID		0002000			/* set gid on exec */
#define	C_ISVTX		0001000			/* t bit (reserved) */
#define	C_ISDIR		0040000			/* is a directory */
#define	C_ISFIFO	0010000			/* is a FIFO */
#define	C_ISREG		0100000			/* is a regular file */
#define	C_ISBLK		0060000			/* is block device */
#define	C_ISCHR		0020000			/* is char device */
#define	C_ISCTG		0110000			/* ? (reserved) */
#define	C_ISLNK		0120000			/* is a link (reserved) */
#define	C_ISSOCK	0140000			/* is a socket (reserved) */

/* Magic string for header */
#define	MAGIC		"070707"

#endif	__cpio_h

/* EOF cpio.h */
