/*
 * $Header: /smsa/bsd:include/dev/ascii.h:bsd  1.5  $
 * $Source: /smsa/bsd:include/dev/ascii.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 *
 */
/* ascii.h
 *
 * standard ASCII names for character codes
 *
 */

#ifndef	__dev_ascii_h
#define	__dev_ascii_h

#define NUL    0
#define SOH    1
#define STX    2
#define ETX    3
#define EOT    4
#define ENQ    5
#define ACK    6
#define BEL    7
#define BS     8
#define HT     9
#define LF    10
#define VT    11
#define FF    12
#define CR    13
#define SO    14
#define SI    15
#define DLE   16
#define DC1   17
#define DC2   18
#define DC3   19
#define DC4   20
#define NAK   21
#define SYN   22
#define ETB   23
#define CAN   24
#define EM    25
#define SUB   26
#define ESC   27
#define FS    28
#define GS    29
#define RS    30
#define US    31
#define SP    32

#define XON  DC1
#define XOFF DC3

             
#define DEL  127

/* extended codes in 8-bit set */

#define IND  132
#define NEL  133
#define SSA  134
#define ESA  135
#define HTS  136
#define HTJ  137
#define VTS  138
#define PLD  139
#define PLU  140
#define RI   141
#define SS2  142
#define SS3  143
#define DCS  144
#define PU1  145
#define PU2  146
#define STS  147
#define CCH  148
#define MW   149
#define SPA  150
#define EPA  151

#define CSI  155
#define ST   156
#define OSC  157
#define PM   158
#define APC  159

/* macro to form control code values from chars */
#ifndef CNTRL
#define CNTRL(ch) ((ch) & 0x1F)
#endif

#endif/*__dev_ascii_h*/

/* EOF ascii.h */
