/*
 * $Header: /smsa/bsd:include/dev/chardefmac.h:bsd  1.4  $
 * $Source: /smsa/bsd:include/dev/chardefmac.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 */

#ifndef __dev_chardefmac_h
#define __dev_chardefmac_h

/* chardefmac.h
 *
 * Some devious (and dubious!) macros to encode
 * the VTE character definition bitmaps
 */

#define ____ 0
#define ___W 1
#define __W_ 2
#define __WW 3
#define _W__ 4
#define _W_W 5
#define _WW_ 6
#define _WWW 7
#define W___ 8
#define W__W 9
#define W_W_ 10
#define W_WW 11
#define WW__ 12
#define WW_W 13
#define WWW_ 14
#define WWWW 15

/*
 * 8-pixel-wide characters are defined using e.g.
 *  B_8 (_,W,_,_,_,_,_,W,W,_)
 * to give a visible form for each row.
 */

#define B_8(b0,b1,b2,b3,b4,b5,b6,b7) \
  b7/**/b6/**/b5/**/b4<<4 | b3/**/b2/**/b1/**/b0

/*
 * For 12-pixel-wide characters, use e.g.
 *  B_12 (_,_,W,W,W,W,W,W,_,_,_,_)
 */

#define B_12(b0,b1,b2,b3,b4,b5,b6,b7,b8,b9,bA,bB) \
  bB/**/bA/**/b9/**/b8<<8 | b7/**/b6/**/b5/**/b4<<4 | b3/**/b2/**/b1/**/b0

#endif/*__dev_chardefmac_h*/

/* EOF chardefmac.h */
