/*
 * $Header: /smsa/bsd:include/dev/chardefs.h:bsd  1.5  $
 * $Source: /smsa/bsd:include/dev/chardefs.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 */
/* chardefs.h */

#ifndef __dev_chardefs_h
#define __dev_chardefs_h

typedef unsigned char FontRow8x10, *FontRow8x10Ref;
typedef struct
{
    FontRow8x10 row[10];
    FontRow8x10 underline;
} CharDef8x10, *CharDef8x10Ref;
#define UNDERLINE_ROW_8x10  8

typedef unsigned short FontRow12x28, *FontRow12x28Ref;
typedef struct 
{
    FontRow12x28 row[28];
    FontRow12x28 underline[2];
} CharDef12x28, *CharDef12x28Ref;
#define UNDERLINE_ROW_12x28  25
extern CharDef12x28 font_12x28_basic[], font_12x28_fine[];

typedef struct 
{
    CharDef8x10Ref cd[127-32+1];
} CharMap8x10, *CharMap8x10Ref;

typedef struct 
{
    CharDef12x28Ref cd[127-32+1];
} CharMap12x28, *CharMap12x28Ref;

CharMap8x10 font_8x10_ISO_base_basic;
CharMap8x10 font_8x10_ISO_base_fine; 
CharMap8x10 font_8x10_DEC_special;
CharMap8x10 font_8x10_DEC_supplemental;
CharMap8x10 font_8x10_ISO_latin_1;

CharMap12x28 font_12x28_ISO_base_basic;
CharMap12x28 font_12x28_ISO_base_fine; 
CharMap12x28 font_12x28_DEC_special;
CharMap12x28 font_12x28_DEC_supplemental;
CharMap12x28 font_12x28_ISO_latin_1;      

#endif/*__dev_chardefs_h*/

/* EOF chardefs.h */
