/*
 * $Header: /smsa/bsd:include/dev/mem.h:bsd  1.5  $
 * $Source: /smsa/bsd:include/dev/mem.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 */

#ifndef __dev_mem_h
#define __dev_mem_h

/* mem.h
 *
 * Definitions of memory organisation on 4MB A-series computer
 *
 */

#define MEG (1024*1024)

#define PAGE_SIZE     (32*1024)  /* 32Kbyte pages */
#define LOG_PAGES     1024       /* available logical memory pages */
#define PHYS_PAGES    128        /* because 128 entries in MEMC CAM */
#define LOGRAM_BASE   0          /* logically mapped RAM starts at 0 */
#define LOGRAM_SIZE   (32*MEG)   /* 32Mb of logical address space */
#define PHYSRAM_BASE  (32*MEG)   /* followed by physical address space */
#define PHYSRAM_SPACE (16*MEG)   /* 16Mb of physical address space */
#define PHYSRAM_SIZE  (4*MEG)    /* but only 4Mb of real RAM */
#define IOAREA_BASE   (48*MEG)   /* I/O space follows phys a/space */
#define IOAREA_SIZE   (16*MEG)   /* 16Mb of I/O address space */

#define SCREEN_PAGES  6          /* standard layout grabs this much at top
                                  * end of logical RAM/start of physical RAM
                                  * for screen memory.
                                  */

#endif/*__dev_mem_h*/

/* EOF mem.h */
