/*
 * $Header: /smsa/bsd:include/dev/repn.h:bsd  1.4  $
 * $Source: /smsa/bsd:include/dev/repn.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 */

#ifndef __dev_repn_h
#define __dev_repn_h

/* repn.h
 *
 * Some initialiser macros for repeating groups of values
 * Provided in powers of two - do your own binary arithmetic!
 */

#define REP2(val)    val,val
#define REP4(val)    REP2(val),REP2(val)
#define REP8(val)    REP4(val),REP4(val)
#define REP16(val)   REP8(val),REP8(val)
#define REP32(val)   REP16(val),REP16(val)
#define REP64(val)   REP32(val),REP32(val)
#define REP128(val)  REP64(val),REP64(val)
#define REP256(val)  REP128(val),REP128(val)

#endif/*__dev_repn_h*/

/* EOF repn.h */
