/*
 * $Header: /smsa/bsd:include/dev/sound.h:bsd  1.6  $
 * $Source: /smsa/bsd:include/dev/sound.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 */

#ifndef __dev_sound_h
#define __dev_sound_h

/* sound.h
 *
 * Definitions for mini sound system
 */

extern void SND_initialise (void);
extern int SND_beep (int /*milliseconds*/, int /*amplitude*/);

/*
 * SND_clock_rate is called by the screen driver module to notify the
 * sound system of the current VIDC input clock rate (in units of
 * kHz): on newer video hardware, different modes use different clock
 * rates; this affects the sound sample rate and hence sound frequency
 * calculations.  The default rate is 24Mhz (= 24000 kHz).
 */
extern void SND_clock_freq (int /*vidc_clock_kHz*/);

#endif/*__dev_sound_h*/

/* EOF sound.h */
