/*	@(#)exportent.h	1.1 88/03/15 4.0NFSSRC SMI	*/

/* 
 * Copyright (c) 1988 by Sun Microsystems, Inc.
 *  1.5 88/02/07 (C) 1986 SMI
 */

#ifndef __exportent_h
#define __exportent_h

/*
 * Exported file system table, see exportent(3)
 */ 

#define TABFILE "/etc/xtab"		/* where the table is kept */

/*
 * Options keywords
 */
#define ACCESS_OPT	"access"	/* machines that can mount fs */
#define ROOT_OPT	"root"		/* machines with root access of fs */
#define RO_OPT		"ro"		/* export read-only */
#define RW_OPT		"rw"		/* export read-mostly */
#define ANON_OPT	"anon"		/* uid for anonymous requests */
#define SECURE_OPT	"secure"	/* require secure NFS for access */
#define WINDOW_OPT	"window"	/* expiration window for credential */

struct exportent {
	char *xent_dirname;	/* directory (or file) to export */
	char *xent_options;	/* options, as above */
};

#ifndef __stdio_h
#include "stdio.h"
#endif

extern FILE *setexportent(void);
extern void endexportent(FILE *);
extern int remexportent(FILE *, char *);
extern int addexportent(FILE *, char *, char *);
extern char *getexportopt(struct exportent *, char *);
extern struct exportent *getexportent(FILE *);

#endif/*__exportent_h*/

/* EOF exportent.h */
