/*
 * $Header: /smsa/bsd:include/net/sl_data.h:bsd  1.4  $
 * $Source: /smsa/bsd:include/net/sl_data.h: $
 *
 * sl_data.h - definitions of structures for use by 
 * if_sl (Serial Line Internet Protocol) module.
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 *
 * Extracted from net/if_sl.c, whose copyright terms are:
 *
 * Copyright (c) 1987 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef __net_sl_data_h
#define __net_sl_data_h

struct sl_softc {
	struct	ifnet sc_if;	/* network-visible interface */
	short	sc_flags;	/* see below */
	short	sc_ilen;	/* length of input-packet-so-far */
	struct	tty *sc_ttyp;	/* pointer to tty structure */
	char	*sc_mp;		/* pointer to next available buf char */
	char	*sc_buf;	/* input buffer */
};

#ifdef	_KERNEL
extern struct sl_softc sl_softc[];
extern int n_sl;
#endif/*_KERNEL*/

/* flags */
#define	SC_ESCAPED	0x0001	/* saw a FRAME_ESCAPE */

#endif/*__net_sl_data_h*/

/* EOF sl_data.h */
