/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 *	@(#)tcp_debug.h	7.3 (Berkeley) 6/29/88
 * $Header: /smsa/bsd:include/netinet/tcp_debug.h:bsd  1.12  $
 * $Source: /smsa/bsd:include/netinet/tcp_debug.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 */
/* @(#)tcp_debug.h	1.1 87/07/01 3.2/4.3NFSSRC */
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)tcp_debug.h	7.1 (Berkeley) 6/5/86
 */

#ifndef __netinet_tcp_debug_h
#define __netinet_tcp_debug_h

struct	tcp_debug {
	n_time	td_time;
	short	td_act;
	short	td_ostate;
	caddr_t	td_tcb;
	struct	tcpiphdr td_ti;
	int	td_req; /* For debugging this stores a char* */
	struct	tcpcb td_cb;
};

#define	TA_INPUT 	0
#define	TA_OUTPUT	1
#define	TA_USER		2
#define	TA_RESPOND	3
#define	TA_DROP		4
#define TA_DEBUG        5  /* KDR special just for debugging */

#ifdef TANAMES
char	*tanames[] =
    { "input", "output", "user", "respond", "drop", "debug" };
#endif

#define	TCP_NDEBUG 100
#ifdef  _KERNEL
#ifdef	 TCP_TRACE
struct	tcp_debug tcp_debug[TCP_NDEBUG];
int	tcp_debx;
#else	 TCP_TRACE
#define	tcp_trace(act,ostate,tp,ti,req)		/* nothing */
#endif	 TCP_TRACE
#endif  _KERNEL


#endif/*__netinet_tcp_debug_h*/

/* EOF tcp_debug.h */
