/*
 * $Header: /smsa/bsd:include/ptof.h:bsd  1.4  $
 * $Source: /smsa/bsd:include/ptof.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 */
/* ptof.h - header for ftop(), ftop_unpack, ptof(), ptof_pack() */
/* Jon Green, Acorn Computers Ltd., 16.7.87 */

#ifndef __ptof_h
#define __ptof_h

#define		PD_SGNS		0	/* Signs of exponent & significand */
#define		PD_EXP		1	/* Start of exponent (r-justified) */
#define		PD_SIG		5	/* Start of significand (l-just'd) */

#define		PD_SIGSGN	0x08	/* Mask for significand sign */
#define		PD_EXPSGN	0x04	/* And exponent sign */

#define		PD_MAX_SIGLEN	18	/* Max. number of digits in sig. */
#define		PD_MAX_EXPLEN	4	/* Ditto exponent */

typedef
	struct
	{	double		pd_double;
		unsigned char	pd_packed[12];
	} pd_struct, *pd_structptr;

extern	unsigned char	ftop_unpack();

#endif/*__ptof_h*/

/* EOF ptof.h */
