/*
 * $Header: /smsa/bsd:include/ranlib.h:bsd  1.5  $
 * $Source: /smsa/bsd:include/ranlib.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 */
/*	ranlib.h	4.1	83/05/03	*/

#ifndef __ranlib_h
#define __ranlib_h

#ifndef __sys_types_h
#include "sys/types.h"
#endif

/*
 * Structure of the __.SYMDEF table of contents for an archive.
 * __.SYMDEF begins with a word giving the number of ranlib structures
 * which immediately follow, and then continues with a string
 * table consisting of a word giving the number of bytes of strings
 * which follow and then the strings themselves.
 * The ran_strx fields index the string table whose first byte is numbered 0.
 */
struct	ranlib {
	union {
		off_t	ran_strx;	/* string table index of */
		char	*ran_name;	/* symbol defined by */
	} ran_un;
	off_t	ran_off;		/* library member at this offset */
};

#endif/*__ranlib_h*/

/* EOF ranlib.h */
