/*
 * $Header: /smsa/bsd:include/rpc/rpc.h:bsd  1.6  $
 * $Source: /smsa/bsd:include/rpc/rpc.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 * Copyright (C) 1984, Sun Microsystems, Inc.
 * Copyright (c) 1988 by Sun Microsystems, Inc.
 *	@(#)rpc.h 1.9 88/02/08 SMI	  
 */

#ifndef __rpc_rpc_h
#define __rpc_rpc_h

/*
 * rpc.h, Just includes the billions of rpc header files necessary to 
 * do remote procedure calling.
 */

#ifndef __rpc_types_h
#include "types.h"		/* some typedefs */
#endif
#ifndef __netinet_in_h
#include "../netinet/in.h"
#endif

/* external data representation interfaces */
#ifndef __rpc_xdr_h
#include "xdr.h"		/* generic (de)serializer */
#endif

/* Client side only authentication */
#ifndef __rpc_auth_h
#include "auth.h"		/* generic authenticator (client side) */
#endif

/* Client side (mostly) remote procedure call */
#ifndef __rpc_clnt_h
#include "clnt.h"		/* generic rpc stuff */
#endif

/* semi-private protocol headers */
#ifndef __rpc_rpc_msg_h
#include "rpc_msg.h"		/* protocol for rpc messages */
#endif
#ifndef __rpc_auth_unix_h
#include "auth_unix.h"		/* protocol for unix style cred */
#endif
#ifndef __rpc_auth_des_h
#include "auth_des.h"		/* protocol for des style cred */
#endif

/* Server side only remote procedure callee */
#ifndef __rpc_svc_h
#include "svc.h"		/* service manager and multiplexer */
#endif
#ifndef __rpc_svc_auth_h
#include "svc_auth.h"		/* service side authenticator */
#endif

#endif/*__rpc_rpc_h*/

/* EOF rpc.h */
