/*
 * $Header: /smsa/bsd:include/sys/bootconf.h:bsd  1.5  $
 * $Source: /smsa/bsd:include/sys/bootconf.h: $
 *
 * Copyright (c) 1989 Acorn Computers Ltd., Cambridge, England
 *
 */
/*	@(#)bootconf.h	2.1 88/05/18 NFSSRC4.0 from 1.1 87/01/12 SMI	*/

#ifndef	__sys_bootconf_h
#define	__sys_bootconf_h

/*
 * Boot time configuration information objects
 */

#define	MAXFSNAME	16
#define	MAXOBJNAME	128
/*
 * Boot configuration information
 */
struct bootobj {
	char	bo_fstype[MAXFSNAME];	/* filesystem type name (e.g. nfs) */
	char	bo_name[MAXOBJNAME];	/* name of object */
	int	bo_flags;		/* flags, see below */
	int	bo_size;		/* number of blocks */
	time_t	bo_time;		/* time object created (if root, time booted) */
	struct vnode *bo_vp;		/* vnode of object */
};

/*
 * flags
 */
#define	BO_VALID	0x01		/* all information in object is valid */
#define	BO_BUSY		0x02		/* object is busy */

#ifdef	_KERNEL
struct bootobj rootobj;
struct bootobj dumpobj;
struct bootobj swapobj;
#endif

#endif/*__sys_bootconf_h*/

/* EOF bootconf.h */
