/*
 * $Header: /smsa/bsd:include/sys/callout.h:bsd  1.7  $
 * $Source: /smsa/bsd:include/sys/callout.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 *
 */
/*	@(#)callout.h	2.1 88/05/18 4.0NFSSRC SMI;	*/
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)callout.h	7.1 (Berkeley) 6/4/86
 */

#ifndef	__sys_callout_h
#define	__sys_callout_h

#ifndef	__sys_types_h
#include "types.h"
#endif

/*
 * The callout structure is for
 * a routine arranging
 * to be called by the clock interrupt
 * (clock.c) with a specified argument,
 * in a specified amount of time.
 * Used, for example, to time tab
 * delays on typewriters.
 */

struct	callout {
	int	c_time;		/* incremental time */
	caddr_t	c_arg;		/* argument to routine */
	int	(*c_func)();	/* routine */
	struct	callout *c_next;
};
#ifdef	_KERNEL
struct	callout *callfree, *callout, calltodo;
int	ncallout;
#endif	_KERNEL

#endif/*__sys_callout_h*/

/* EOF callout.h */
