/*
 * $Header: /smsa/bsd:include/sys/domain.h:bsd  1.8  $
 * $Source: /smsa/bsd:include/sys/domain.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 *
 */
/* @(#)domain.h	1.2 87/05/15 3.2/4.3NFSSRC */
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)domain.h	7.1 (Berkeley) 6/4/86
 */

#ifndef	__sys_domain_h
#define	__sys_domain_h

/*
 * Structure per communications domain.
 */
struct	domain {
	int	dom_family;		/* AF_xxx */
	char	*dom_name;
	int	(*dom_init)();		/* initialize domain data structures */
	int	(*dom_externalize)();	/* externalize access rights */
	int	(*dom_dispose)();	/* dispose of internalized rights */
	struct	protosw *dom_protosw, *dom_protoswNPROTOSW;
	struct	domain *dom_next;
};

#ifdef	_KERNEL
struct	domain *domains;
#ifdef	INET
struct	domain inetdomain;
#endif
#endif

#endif/*__sys_domain_h*/

/* EOF domain.h */
