/*
 * $Header: /smsa/bsd:include/sys/ptrace.h:bsd  1.8  $
 * $Source: /smsa/bsd:include/sys/ptrace.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 *
 */
/* @(#)ptrace.h	1.2 87/05/15 3.2/4.3NFSSRC */
/*
 * Copyright (c) 1980, 1986 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)ptrace.h	7.1 (Berkeley) 6/4/86
 */

#ifndef	__sys_ptrace_h
#define	__sys_ptrace_h

/*
 * Machine dependent constants
 */
#ifndef __machine_trap_h
#include "../machine/trap.h"
#endif

#define PT_TRACE_ME	0	/* child declares it's being traced */
#define PT_READ_I	1	/* read word in child's I space */
#define PT_READ_D	2	/* read word in child's D space */
#define PT_READ_U	3	/* read word in child's user structure */
#define PT_WRITE_I	4	/* write word in child's I space */
#define PT_WRITE_D	5	/* write word in child's D space */
#define PT_WRITE_U	6	/* write word in child's user structure */
#define PT_CONTINUE	7	/* continue the child */
#define PT_KILL		8	/* kill the child process */
#define PT_STEP		9	/* single step the child */

/*
 *	This file contains definitions of SWI instructions used in the
 *	ptrace system call.
 *
 *	The following SWI is the standard one which debuggers plant in the
 *	instruction stream to set a breakpoint.
 */

#define	BKPT_SWI	(0xEF000000 | SWI_OS_UNIX | SWI_PTRACE)

/*
 *	The following SWI is planted automatically by the kernel to simulate
 *	single-shotting.
 */

#define	SSHOT_SWI	(0xEF000001 | SWI_OS_UNIX | SWI_PTRACE)

#endif/*_sys_ptrace_h_*/

/* EOF ptrace.h */
