/*
 * $Header: /smsa/bsd:include/sys/sysinfo.h:bsd  1.7  $
 * $Source: /smsa/bsd:include/sys/sysinfo.h: $
 *
 * Copyright (c) 1990 Acorn Computers Ltd., Cambridge, England
 *
 */

#ifndef __sys_sysinfo_h
#define __sys_sysinfo_h

#ifndef	_KERNEL
extern int getsysinfo (int /*code*/, void * /*buff*/, int /*len*/);
#endif/*_KERNEL*/

/* Codes for system information */
#define SI_MACHINE_TYPE_I	1	/* long: machine type number: R140, R200 */
#define SI_MACHINE_TYPE_S	2	/* string: machine type "R140","R200",.. */
#define SI_KERNEL_VSN_D		3	/* data: kernel version structure */
#define SI_HOST_NAME_S		4	/* string: host name */
#define SI_HOST_ID_I		5	/* long: hardware host id */
#define SI_DOMAIN_NAME_S	6	/* string: domain name */
#define SI_ROOT_OBJ_D		7	/* data: root object */
#define SI_CPU_TYPE_S		8	/* string: basic cpu type, e.g. "ARM" */
#define SI_CPU_VERSION_I	9	/* long: cpu version 2(ARM2),3(ARM3) */
#define SI_OS_NAME_S		10	/* e.g. "RISC iX" */
#define SI_OS_RELEASE_S		11	/* e.g. "1.2" */
#define SI_OS_VERSION_S		12	/* e.g. "0" */
#define SI_CHILD_MAX_I		13	/* long: max procs/uid */
#define SI_ARG_MAX_I		14	/* long: max args/env bytes */
#define SI_OPEN_MAX_I		15	/* long: max fds/proc */
#define SI_CLK_TCK_I		16	/* long: clock freq (Hz) */
#endif/*__sys_sysinfo_h*/

/* EOF sysinfo.h */
